/*-
 * Copyright (c) 2004 Michael Bushkov <bushman@rsu.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __GROUP_DEFS_H__
#define __GROUP_DEFS_H__

#include <grp.h>

/* structure for group requests results */
struct group_result {
	struct group	grp_result;		/* the result itself */
	char		*grp_buffer;		/* buffer (pointers from grp_result point to grp_buffer's memory */
	size_t		grp_buffer_size;	/* size of grp_buffer */
};

/* getgrnam request data */
struct getgrnam_data {
	size_t	name_size;	/* length of name */
	char	*name;		/* name parameter of getgrnam */
};

/* getgrgid request data */
struct getgrgid_data {
	gid_t	gid;	/* gid parameter of getgrgid function */
};

/* request data for getgrent function */
struct getgrent_data {
	size_t	cursor_size;	/* cursor size */
	void	*cursor_buffer;	/* cursor - a void * pointer, used by snapshots */
};

#endif
